/*

ESUP-portail is a french academic project developed under the GPL (General Public License)
augmented according to the following :

A binary or source file developped by ESUP-portail can be used or compiled with products under Apache license.

The official english text of the GPL can be found here : http://www.gnu.org/licenses/gpl.html .

A non official french translation can be found here : http://www.linux-France.org/article/these/gpl.html .

The different kinds of licenses governing the products developed by the Apache
foundation can be found here : http://www.apache.org/licenses .

It follows that you can as well as use download contents as well modify and redistribute
them provided you respect the GPL terms.

Downloading and using such contents do not provide any guaranty.

Be sure that you have well understood the terms of the license before using the contents it covers.

The ESUP-portail distribution includes the following distributions :

* UPortal :
software developed by JA-SIG (Java Architecture - Special Interest Group)
You can find the license page here : http://mis105.udel.edu/ja-sig/uportal/license.html

* CAS :
SSO solution developed by Yale University
You can find the project page here : http://www.yale.edu/tp/auth

* Cocoon :
XML framework distributed by the Apache foundation under Apache license;
Please find the full text here : http://cocoon.apache.org/2.1/license.html

* Mod_dav:
A DAV module for Apache web server
You can find the project page here : http://www.webdav.org/mod_dav

* IMP :
webmail from Horde application framework
You can find the project page here : http://www.horde.org
*/
package org.esupportail.portal.channels.CAnnuaire.config;

import java.util.Vector;

public class itemTable {


	/**
	 * Represente le code de l'lment
	 */
	private String code;
	
	/**
	 * Represente la valeur de l'lment
	 */
	private String value;
	
	/**
	 * Represente la valeur de l'lment qui sert de tri
	 */
	private String orderValue;
	
	/**
	 * Represente la valeur de l'lment pour lier  une autre table
	 */
	private String linkedValue;

	private Vector subElement;

	/**
	 * Retourne le code de l'lment
	 * 
	 * @return le code
	 */
	public String getCode() {
		return code;
	}

	/**
	 * Retroune la valeur de tride l'lment
	 * 
	 * @return la valeur de tri
	 */
	public String getOrderValue() {
		if (orderValue != null)
			return orderValue;
		else
			return value;
	}

	/**
	 * Retroune la valeur de l'lment
	 * 
	 * @return la valeur
	 */
	public String getValue() {
		return value;
	}

	/**
	 * Dfinit le code de l'lment
	 * 
	 * @param string
	 */
	public void setCode(String string) {
		code = string;
	}

	/**
	 * Dfinit la valeur de tri de l'lment
	 * 
	 * @param string
	 */
	public void setOrderValue(String string) {
		orderValue = string;
	}

	/**
	 * Dfinit la valeur de l'lment
	 * 
	 * @param string
	 */
	public void setValue(String string) {
		value = string;
	}

	public Vector getSubElement() {
		return subElement;
	}

	public void setSubElement(Vector subElement) {
		this.subElement = subElement;
	}

	public String getLinkedValue() {
		return linkedValue;
	}

	public void setLinkedValue(String linkedValue) {
		this.linkedValue = linkedValue;
	}

}
